#
# Conditional build:
%bcond_without	glamor		# glamor dix module
%bcond_with	xcsecurity	# XC-SECURITY extension (deprecated)
%bcond_with	xf86bigfont	# XF86BigFont extension
%bcond_without	xselinux	# XSELINUX extension
%bcond_without	libunwind	# libunwind for backtracing
%bcond_with	systemtap	# systemtap/dtrace probes
%bcond_without	doc		# don't build documentation

Summary:	Xwayland - X server integrated into a Wayland window system
Summary(pl.UTF-8):	Xwayland - serwer X integrowalny w Wayland
Name:		xorg-xserver-Xwayland
Version:	24.1.4
Release:	1
License:	MIT
Group:		X11/Servers
Source0:	https://xorg.freedesktop.org/releases/individual/xserver/xwayland-%{version}.tar.xz
# Source0-md5:	c0d6f4a2c16844c7af70e30e330ace3c
Patch0:		gcc14.patch
URL:		https://xorg.freedesktop.org/
BuildRequires:	Mesa-dri-devel
%{?with_glamor:BuildRequires:	Mesa-libgbm-devel >= 21.3}
BuildRequires:	OpenGL-devel >= 1.2
%{?with_xselinux:BuildRequires:	audit-libs-devel}
BuildRequires:	docbook-dtd43-xml
BuildRequires:	libbsd-devel
BuildRequires:	libdecor-devel
BuildRequires:	libdrm-devel >= 2.4.116
BuildRequires:	libei-devel >= 1.0.0
%{?with_glamor:BuildRequires:	libepoxy-devel}
# also possible: libmd, libsha, nettle, openssl
BuildRequires:	libgcrypt-devel
BuildRequires:	liboeffis-devel >= 1.0.0
%{?with_xselinux:BuildRequires:	libselinux-devel >= 2.0.86}
BuildRequires:	libtirpc-devel
%{?with_libunwind:BuildRequires:	libunwind-devel}
BuildRequires:	meson >= 0.56.0
BuildRequires:	ninja >= 1.5
BuildRequires:	pixman-devel
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.736
%{?with_systemtap:BuildRequires:	systemtap-sdt-devel}
BuildRequires:	tar >= 1:1.22
# wayland-client
BuildRequires:	wayland-devel >= 1.21.0
BuildRequires:	wayland-protocols >= 1.34
%{?with_doc:BuildRequires:	xmlto}
BuildRequires:	xorg-lib-libX11-devel
BuildRequires:	xorg-lib-libXau-devel
BuildRequires:	xorg-lib-libXdmcp-devel
BuildRequires:	xorg-lib-libXext-devel >= 1.0.99.4
BuildRequires:	xorg-lib-libXfont2-devel >= 2.0
BuildRequires:	xorg-lib-libxcvt-devel
BuildRequires:	xorg-lib-libxkbfile-devel
BuildRequires:	xorg-lib-libxshmfence-devel >= 1.1
BuildRequires:	xorg-lib-xtrans-devel >= 1.3.5
BuildRequires:	xorg-proto-bigreqsproto-devel >= 1.1.0
BuildRequires:	xorg-proto-compositeproto-devel >= 0.4
BuildRequires:	xorg-proto-damageproto-devel >= 1.1
BuildRequires:	xorg-proto-dpmsproto-devel >= 1.2
BuildRequires:	xorg-proto-dri3proto-devel >= 1.4
BuildRequires:	xorg-proto-fixesproto-devel >= 6.0
BuildRequires:	xorg-proto-fontsproto-devel >= 2.1.3
BuildRequires:	xorg-proto-glproto-devel >= 1.4.17
BuildRequires:	xorg-proto-inputproto-devel >= 2.3
BuildRequires:	xorg-proto-kbproto-devel >= 1.0.3
BuildRequires:	xorg-proto-presentproto-devel >= 1.4
BuildRequires:	xorg-proto-randrproto-devel >= 1.6.0
BuildRequires:	xorg-proto-recordproto-devel >= 1.13.99.1
BuildRequires:	xorg-proto-renderproto-devel >= 0.11
BuildRequires:	xorg-proto-resourceproto-devel >= 1.2.0
BuildRequires:	xorg-proto-scrnsaverproto-devel >= 1.1
BuildRequires:	xorg-proto-videoproto-devel
BuildRequires:	xorg-proto-xcmiscproto-devel >= 1.2.0
BuildRequires:	xorg-proto-xextproto-devel >= 7.2.99.901
%{?with_xf86bigfont:BuildRequires:	xorg-proto-xf86bigfontproto-devel >= 1.2.0}
BuildRequires:	xorg-proto-xf86vidmodeproto-devel >= 2.2.99.1
BuildRequires:	xorg-proto-xineramaproto-devel
BuildRequires:	xorg-proto-xproto-devel >= 7.0.31
BuildRequires:	xorg-proto-xwaylandproto-devel >= 1.0
%{?with_doc:BuildRequires:	xorg-sgml-doctools}
BuildRequires:	xz
%{?with_glamor:Requires:	Mesa-libgbm >= 21.3}
Requires:	libdrm >= 2.4.116
Requires:	libei >= 1.0.0
Requires:	liboeffis >= 1.0.0
%{?with_xselinux:Requires:	libselinux >= 2.0.86}
Requires:	wayland >= 1.21.0
Requires:	xorg-app-xkbcomp
Requires:	xorg-lib-libXext >= 1.0.99.4
Requires:	xorg-lib-libXfont2 >= 2.0
Requires:	xorg-lib-libxshmfence >= 1.1
# for protocol.txt
Requires:	xorg-xserver-common >= 1.20
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Xwayland - server integrated into a Wayland window system.

%description -l pl.UTF-8
Xwayland - serwer X integrowalny w Wayland.

%package devel
Summary:	Development file for Xwayland server
Summary(pl.UTF-8):	Plik programistyczny serwera Xwayland
Group:		Development/Libraries

%description devel
Development file for Xwayland server, containing server build
configuration.

%description devel -l pl.UTF-8
Plik programistyczny serwera Xwayland, zawierający konfigurację
zbudowanego serwera.

%prep
%setup -q -n xwayland-%{version}
%patch0 -p1

%build
%meson build \
	-Dbuilder_addr="feedback@pld-linux.org" \
	-Dbuilder_string="%{name}-%{version}-%{release}" \
	-Ddefault_font_path="%{_fontsdir}/misc,%{_fontsdir}/TTF,%{_fontsdir}/OTF,%{_fontsdir}/Type1,%{_fontsdir}/100dpi,%{_fontsdir}/75dpi" \
	-Ddevel-docs=%{__true_false doc} \
	-Ddocs=%{__true_false doc} \
	-Ddocs-pdf=false \
	%{?with_systemtap:-Ddtrace=true} \
	%{!?with_glamor:-Dglamor=false} \
	%{?with_libunwind:-Dlibunwind=true} \
	-Dsha1=libgcrypt \
	-Dvendor_name="PLD Linux" \
	%{?with_xcsecurity:-Dxcsecurity=true} \
	%{?with_xf86bigfont:-Dxf86bigfont=true} \
	-Dxkb_bin_dir=%{_bindir} \
	-Dxkb_dir=%{_datadir}/X11/xkb \
	-Dxkb_output_dir=/var/lib/xkb \
	%{!?with_xselinux:-Dxselinux=false}

%ninja_build -C build

%install
rm -rf $RPM_BUILD_ROOT

%ninja_install -C build

# xorg-xserver-common package (common dependency for Xwayland and Xorg)
%{__rm} $RPM_BUILD_ROOT%{_libdir}/xorg/protocol.txt
%{__rm} $RPM_BUILD_ROOT%{_mandir}/man1/Xserver.1

%{?with_doc:%{__rm} $RPM_BUILD_ROOT%{_docdir}/xorg-server/Xserver-DTrace.*}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc COPYING README.md
%attr(755,root,root) %{_bindir}/Xwayland
%{_desktopdir}/org.freedesktop.Xwayland.desktop
%{_mandir}/man1/Xwayland.1*

%files devel
%defattr(644,root,root,755)
%{?with_doc:%doc build/doc/{Xinput,Xserver-spec}.html build/doc/dtrace/Xserver-DTrace.html}
%{_pkgconfigdir}/xwayland.pc
%changelog
* Wed Oct 30 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/xorg-xserver-Xwayland.git;a=log;h=master

* Tue Oct 29 2024 Jan Palus <atler@pld-linux.org> 1d5f5ff
- up to 24.1.4 (fixes CVE-2024-9632)

* Thu Oct 03 2024 Jan Palus <atler@pld-linux.org> ac7ba5f
- up to 24.1.3

* Mon Aug 12 2024 Jan Palus <atler@pld-linux.org> 7fbee8f
- fix 32bit build with gcc 14; rel 2

* Thu Aug 08 2024 Jan Palus <atler@pld-linux.org> 4de1809
- up to 24.1.2

* Thu Jul 11 2024 Jan Palus <atler@pld-linux.org> be48025
- up to 24.1.1

* Wed May 15 2024 Jan Palus <atler@pld-linux.org> 8ac6883
- up to 24.1.0

* Sat Apr 13 2024 Jan Palus <atler@pld-linux.org> 5eb757c
- up to 23.2.6

* Wed Apr 03 2024 Jakub Bogusz <qboosh@pld-linux.org> e10c4bc
- updated to 23.2.5 (fixes CVE-2024-31080 CVE-2024-31081 CVE-2024-31083)

* Tue Jan 16 2024 Jan Palus <atler@pld-linux.org> 8d881f0
- up to 23.2.4 (security fixes)

* Wed Dec 13 2023 Jan Palus <atler@pld-linux.org> b9f3e2f
- up to 23.2.3 (fixes CVE-2023-6377 CVE-2023-6478)

* Wed Oct 25 2023 Jan Palus <atler@pld-linux.org> 214beaa
- up to 23.2.2 (fixes CVE-2023-5367)

* Wed Sep 20 2023 Jan Palus <atler@pld-linux.org> e94c8fc
- up to 23.2.1

* Wed Aug 16 2023 Jan Palus <atler@pld-linux.org> 5ebab00
- up to 23.2.0

* Wed Jun 07 2023 Jan Palus <atler@pld-linux.org> 7ef0e59
- up to 23.1.2

* Thu Mar 30 2023 Jan Palus <atler@pld-linux.org> 6fadb67
- up to 23.1.1 (fixes CVE-2023-1393)

* Wed Mar 22 2023 Jan Palus <atler@pld-linux.org> a25d0ec
- up to 23.1.0

* Tue Feb 07 2023 Jan Palus <atler@pld-linux.org> 70426a8
- up to 22.1.8 (fixes CVE-2023-0494)

* Tue Dec 20 2022 Jan Palus <atler@pld-linux.org> 91a2a38
- up to 22.1.7

* Wed Dec 14 2022 Jan Palus <atler@pld-linux.org> f9cc248
- BR: pkgconfig

* Wed Dec 14 2022 Jan Palus <atler@pld-linux.org> 2cceab7
- up to 22.1.6

